#!/usr/local/perl/bin/perl

use NetCDF;
$numcolorParts = 3;
$colorNumbers = 256;
 if ($#ARGV != 1) {
	print "Usage filenametoread filenametooutputto\n";
	exit(1);
}
$file = $ARGV[0];
$outputfile = $ARGV[1];

$ncidread = NetCDF::open($file, NOWRITE);

##Find out numTables value
$numTablesid = NetCDF::dimid($ncidread, 'numTables');
NetCDF::diminq($ncidread, $numTablesid, $name, $numTablesvar);

##get stringLength 
$stringLengthid = NetCDF::dimid($ncidread, 'stringLength');
NetCDF::diminq($ncidread, $stringLengthid, $name, $stringLengthvar);
$totalvalue =0;
#Read out table names
foreach $value (0..$numTablesvar-1) {
	@start = ($value,0);
	@count = (1,$stringLengthvar);

	@startkeys = ($value,0);
	@countkeys = (1,1);


	$tableNamesvarid=NetCDF::varid($ncidread,"tableNames");
	$tableKeysvarid=NetCDF::varid($ncidread,"tableKeys");

	NetCDF::varget($ncidread,$tableNamesvarid,\@start,\@count,\@name);
	NetCDF::varget($ncidread,$tableKeysvarid,\@startkeys,\@countkeys,\@keys);
	print "$value:".process(\@name)."\n";
	$totalvalue = $value;
}
print "Which curve do you want extracted: ";
$idin = <STDIN>;
chop($idin);
if (!-e $outputfile ) {
	`cp blankColorMaps.nc $outputfile`;
}
if ($idin eq "ALL") {
	@ids = (0..$totalvalue);
} else {
	@ids = split(",",$idin);
}
##################################################################################################
##################################################################################################
$outputnetcdf = NetCDF::open($outputfile, WRITE);
print "Transfering color curves from $file to $outputfile\n";
	$tableKeysvaridnew=NetCDF::varid($ncidread,"tableKeys");
	$tableNamesvarid=NetCDF::varid($ncidread,"tableNames");
	$colortablevarid=NetCDF::varid($ncidread,"tableColors");
	$tableNamesvarid=NetCDF::varid($ncidread,"tableNames");
	$stringLengthidOUT = NetCDF::dimid($outputnetcdf, 'stringLength');
	NetCDF::diminq($outputnetcdf, $stringLengthidOUT, $nameOUT, $stringLengthvarOUT);
	$colorvarid=NetCDF::varid($outputnetcdf,"tableColors");
foreach $id (@ids) {
	##Find out numTables value
	$numTablesidoutput = NetCDF::dimid($outputnetcdf, 'numTables');
	NetCDF::diminq($outputnetcdf, $numTablesidoutput, $name, $numTablesvaroutput);
	@startkeysoutkey = (0);
	@countkeysoutkey = ($numTablesvaroutput);
	if ($numTablesvaroutput > 0) {
		NetCDF::varget($outputnetcdf,$tableKeysvaridnew,\@startkeysoutkey,\@countkeysoutkey,\@keysit);
		$keyout = $keysit[-1]+1;
	} else {
		$keyout = 1000;
	}

	##Find out numTables value
	$numTablesidout = NetCDF::dimid($outputnetcdf, 'numTables');
	NetCDF::diminq($outputnetcdf, $numTablesidout, $name, $numTablesvarout);
	###Read out data
	@startnameout = ($id,0);
	@countnameout = (1,$stringLengthvar);
	NetCDF::varget($ncidread,$tableNamesvarid,\@startnameout,\@countnameout,\@namein);
	#####Read out color map needed
	@startcolormap = ($id,0,0);
	@countcolormap = (1,$numcolorParts,$colorNumbers);
	NetCDF::varget($ncidread,$colortablevarid,\@startcolormap,\@countcolormap,\@mapin);
	NetCDF::varget($ncidread,$tableNamesvarid,\@startnameout,\@countnameout,\@namein);
	###Write id
	$tableKeysvaridnew=NetCDF::varid($outputnetcdf,"tableKeys");
	@keyouttoday = ($keyout);
	@startwritekey = ($numTablesvarout);
	@countwritekey = (1);
	NetCDF::varput($outputnetcdf,$tableKeysvaridnew,\@startwritekey,\@countwritekey,\@keyouttoday);
	###Write name
	print "Writing ".process(\@namein)."\n";
	@startkeyname = ($numTablesvarout,0);
	@countkeyname = (1,$stringLengthvarOUT);
	NetCDF::varput($outputnetcdf,$tableNamesvarid,\@startkeyname,\@countkeyname,\@namein);

	###Write Table data
	@startcolormapout = ($numTablesvarout,0,0);
	@countcolormapout = (1,$numcolorParts,$colorNumbers);
	NetCDF::varput($outputnetcdf,$colorvarid,\@startcolormapout,\@countcolormapout,\@mapin);
}
NetCDF::close($outputnetcdf);
sub process() {
	($ref) = @_;
	@list = @$ref;
	return(pack("C*",@list));
}

